theory SupInf = Lubs:


constdefs
  Lub :: "'a set \<Rightarrow> 'a::ord"
  "Lub S == SOME x. isLub UNIV S x"

  greatestP:: "['a =>bool,'a::ord] => bool"
  "greatestP P x == (P x & Collect P *<= x)"

  isLb        :: "['a set, 'a set, 'a::ord] => bool"     
  "isLb R S x   == x <=* S & x: R"

  isGlb       :: "['a set, 'a set, 'a::ord] => bool"
  "isGlb R S x == greatestP (isLb R S) x"

  lbs  :: "['a set, 'a::ord set] => 'a set"
  "lbs R S == Collect (isLb R S)"

  Glb :: "'a set \<Rightarrow> 'a::ord"
  "Glb S == SOME x. isGlb UNIV S x"

  isSup:: "'a set \<Rightarrow> ('a \<Rightarrow> 'b) \<Rightarrow> 'b::ord \<Rightarrow> bool"
  "isSup U f a == isLub UNIV (f ` U) a"

  supremum:: "'a set \<Rightarrow> ('a \<Rightarrow> 'b) \<Rightarrow> 'b::ord" 
  "supremum U f == Lub (f ` U)" 

  isInf:: "'a set \<Rightarrow> ('a \<Rightarrow> 'b) \<Rightarrow> 'b::ord \<Rightarrow> bool"
  "isInf U f a == isGlb UNIV (f ` U) a"

  infimum:: "'a set \<Rightarrow> ('a \<Rightarrow> 'b) \<Rightarrow> 'b::ord" 
  "infimum U f == Glb (f ` U)"

syntax
  "_sup" :: "idt => 'a set => 'b => 'b::ord"    ("sup _:_. _" [0, 51, 10] 10)
syntax (xsymbols)
  "_sup" :: "idt => 'a set => 'b => 'b::ord"    ("sup _\<in>_. _" [0, 51, 10] 10)
translations
  "sup i:A. b" == "supremum A (%i. b)"  

syntax
  "_inf" :: "idt => 'a set => 'b => 'b::ord"    ("inf _:_. _" [0, 51, 10] 10)
syntax (xsymbols)
  "_inf" :: "idt => 'a set => 'b => 'b::ord"    ("inf _\<in>_. _" [0, 51, 10] 10)
translations
  "inf i:A. b" == "infimum A (%i. b)"
end
  