lemma assumes ne:"\<exists>X. X\<in>S" and lb:"\<exists>Y. isLb (UNIV::real set) S Y"
  shows reals_complete2: "\<exists>t. isGlb (UNIV :: real set) S t"
proof -
  from ne lb obtain X Y where "X\<in>S" and lbc:"isLb (UNIV::real set) S Y" by auto
  hence nec:"-X\<in>{s. -s \<in> S}" and lbc:"isUb (UNIV::real set) {s. -s \<in> S} (-Y)" 
    by (auto simp add: isLb_def isUb_def setge_def setle_def)
  from nec have  "\<exists>X. X\<in>{s. -s \<in> S}" by (rule exI)
  also from lbc have "\<exists>Y. isUb (UNIV::real set) {s. -s \<in> S} Y" by (rule exI)
  ultimately have "\<exists>t. isLub (UNIV :: real set) {s. -s \<in> S} t" by (rule reals_complete)
  then obtain t where lub:"isLub (UNIV :: real set) {s. -s \<in> S} t" by fast
  hence "isGlb (UNIV :: real set) S (-t)" 
  proof -
    { fix y assume "y \<in> S" 
      with lub have "-y \<le> t" by (auto simp add: isLub_def isUb_def leastP_def setge_def setle_def)
      hence "-t \<le> y"  by (simp only: real_minus_le)}
    also 
    {
      fix z assume "\<forall>y \<in> S. z \<le> y"
      hence "\<forall>y \<in> S. -y \<le> -z" by simp
      hence "\<forall>y. -y \<in> S \<longrightarrow> y \<le> -z" by auto
      with lub have "t \<le> -z" by (simp add: isLub_def isUb_def leastP_def setge_def setle_def)
      hence "z \<le> -t" by simp
    }
    ultimately show ?thesis by (simp add: isGlb_def isLb_def greatestP_def setge_def setle_def)
  qed
  thus ?thesis by fast
qed

    (*The naming on this isn't quite consistent with ours, since we use
    the name reals for a set*)

lemma assumes nn:"non_negative (f::'a \<Rightarrow> real)" and ne:"X \<noteq> {}"
 shows nn_inf_exists: "\<exists>k.  isInf X f k" 
proof -
  from ne have "\<exists>y. y \<in> (f ` X)" by fast
  also
  from nn have "\<exists>x. isLb UNIV (f ` X) x" 
    by (auto simp add: non_negative_def isLb_def setge_def)
  ultimately
  have "\<exists>k. isGlb UNIV (f ` X) k" by (rule reals_complete2)
  thus ?thesis by (simp only: isInf_def)
qed

(*This is trivially stronger than sumr_split_add, and in meta form*)

lemma sumr_split_add4: "n \<le> p \<Longrightarrow> sumr 0 n f + sumr n p f = sumr 0 p f"
proof (cases "n=p")
  case True
  thus ?thesis by simp
next
  case False
  also assume "n \<le> p"
  finally show ?thesis by (rule sumr_split_add)
qed

lemma fin_sum: "\<forall>m. n \<le> m \<longrightarrow> x m = 0 \<Longrightarrow> (\<Sum>i. x i) = (sumr 0 n x)"
  by (simp add: sums_unique[THEN sym] series_zero) 


theorem first_moment_method: 
  assumes "non_negative f" and "0 < \<integral> f \<partial> M"
  shows "law M f {0} < 1"
sorry (*By elementary means*)

theorem fmm:
  assumes "non_negative f" and "0 < \<integral> f d M"
  shows "\<exists>s. 0 < f s"
sorry (*By fmm, measure_space properties*)
